
/*
 DONT EDIT THIS FILE, IT IS GENERATED BY generate_composers
*/

#include "composers.h"
#include <stdio.h>

// Compose two RGBA pixels and return an RGB pixel.
inline unsigned int compose_pixel(unsigned int opx, unsigned int upx) {
    int alpha = opx >> 24;
    return 
	(((((opx & 0xFF00FF) - (upx & 0xFF00FF)) * alpha) >> 8) + (upx & 0xFF00FF)) & 0xFF00FF |
	(((((opx & 0x00FF00) - (upx & 0x00FF00)) * alpha) >> 8) + (upx & 0x00FF00)) & 0x00FF00;
}


inline void compose_UNKNOWN(unsigned int *ob, unsigned int *ub, Framebuffer *fb)
{
    int pixels = fb->var.xres*fb->var.yres;
    unsigned int *rb = (unsigned int *)fb->fb;
    int i = 0; 
    int red_o = fb->var.red.offset;
    int red_m = ((1 << fb->var.red.length) -1)     << (16 +8-fb->var.red.length);
    int red_b = 16 + 8-fb->var.red.length;
     
    int green_o = fb->var.green.offset;
    int green_m = ((1 << fb->var.green.length) -1) << (8 +8-fb->var.red.length);
    int green_b = 8 + 8-fb->var.green.length;
     
    int blue_o = fb->var.blue.offset;
    int blue_m = (1 << fb->var.blue.length) -1     << (8-fb->var.red.length);
    int blue_b = 8-fb->var.blue.length;

    int bytes_pr_pixel = fb->var.bits_per_pixel >> 3;
     
    while (i < pixels) {
	
	int p = compose_pixel(ob[i],ub[i]);
	int r = (((p & red_m)   >> red_b)   << red_o) | 
	        (((p & green_m) >> green_b) << green_o) | 
	        (((p & blue_m)  >> blue_b)  << blue_o);

	for (int j=0;j<bytes_pr_pixel;++j) {
	    ((unsigned char *)rb)[j] = ((unsigned char *)&r)[j];
	}
	((unsigned char *)rb) += bytes_pr_pixel;
        i++;
     
    }
}
    
inline void compose_UNKNOWN(unsigned int *ob, unsigned int *ub, Framebuffer *fb, int x0, int y0, int x1, int y1)
{

    
    int red_o = fb->var.red.offset;
    int red_m = ((1 << fb->var.red.length) -1)     << (16 +8-fb->var.red.length);
    int red_b = 16 + 8-fb->var.red.length;
     
    int green_o = fb->var.green.offset;
    int green_m = ((1 << fb->var.green.length) -1) << (8 +8-fb->var.red.length);
    int green_b = 8 + 8-fb->var.green.length;
     
    int blue_o = fb->var.blue.offset;
    int blue_m = (1 << fb->var.blue.length) -1     << (8-fb->var.red.length);
    int blue_b = 8-fb->var.blue.length;

    int bytes_pr_pixel = fb->var.bits_per_pixel >> 3;
     

    int line      = x0+y0*fb->var.xres;
    int last_line = y1*fb->var.xres;
    unsigned char *line_rb = ((unsigned char *)fb->fb)+ (x0+y0*fb->var.xres)*bytes_pr_pixel;
    
    while (line < last_line) {
      unsigned int *rb = (unsigned int *)line_rb;
      int i = line;
      int pixels = i+(x1-x0);

      while (i < pixels) {
         
	int p = compose_pixel(ob[i],ub[i]);
	int r = (((p & red_m)   >> red_b)   << red_o) | 
	        (((p & green_m) >> green_b) << green_o) | 
	        (((p & blue_m)  >> blue_b)  << blue_o);

	for (int j=0;j<bytes_pr_pixel;++j) {
	    ((unsigned char *)rb)[j] = ((unsigned char *)&r)[j];
	}
	((unsigned char *)rb) += bytes_pr_pixel;
        i++;
     
      }

      line    += fb->var.xres;
      line_rb += fb->var.xres*bytes_pr_pixel;
    }
}
    
inline void compose_565(unsigned int *ob, unsigned int *ub, Framebuffer *fb)
{
    int pixels = fb->var.xres*fb->var.yres;
    unsigned int *rb = (unsigned int *)fb->fb;
    int i = 0; 
    while (i < pixels) {
	
	int p1 = compose_pixel(ob[i],ub[i]); i++;
	int p2 = compose_pixel(ob[i],ub[i]); i++;
	*(rb++) =  
	    ((p1 & 0xf80000) >> 8) | 
	    ((p1 & 0x00fc00) >> 5) | 
	    ((p1 & 0x0000f8) >> 3) |
	    ((p2 & 0xf80000) << 8) | 
	    ((p2 & 0x00fc00) << 11)| 
	    ((p2 & 0x0000f8) << 13);
     
    }
}
    
inline void compose_565(unsigned int *ob, unsigned int *ub, Framebuffer *fb, int x0, int y0, int x1, int y1)
{

    

    int line      = x0+y0*fb->var.xres;
    int last_line = y1*fb->var.xres;
    unsigned char *line_rb = ((unsigned char *)fb->fb)+ (x0+y0*fb->var.xres)*2;
    
    while (line < last_line) {
      unsigned int *rb = (unsigned int *)line_rb;
      int i = line;
      int pixels = i+(x1-x0);

      while (i < pixels) {
         
	int p1 = compose_pixel(ob[i],ub[i]); i++;
	int p2 = compose_pixel(ob[i],ub[i]); i++;
	*(rb++) =  
	    ((p1 & 0xf80000) >> 8) | 
	    ((p1 & 0x00fc00) >> 5) | 
	    ((p1 & 0x0000f8) >> 3) |
	    ((p2 & 0xf80000) << 8) | 
	    ((p2 & 0x00fc00) << 11)| 
	    ((p2 & 0x0000f8) << 13);
     
      }

      line    += fb->var.xres;
      line_rb += fb->var.xres*2;
    }
}
    
inline void compose_555(unsigned int *ob, unsigned int *ub, Framebuffer *fb)
{
    int pixels = fb->var.xres*fb->var.yres;
    unsigned int *rb = (unsigned int *)fb->fb;
    int i = 0; 
    while (i < pixels) {
	
	int p1 = compose_pixel(ob[i],ub[i]); i++;
	int p2 = compose_pixel(ob[i],ub[i]); i++;
	*(rb++) =  
	    ((p1 & 0xf80000) >> 9) | 
	    ((p1 & 0x00f800) >> 5) | 
	    ((p1 & 0x0000f8) >> 3) |
	    ((p2 & 0xf80000) << 7) | 
	    ((p2 & 0x00f800) << 11)| 
	    ((p2 & 0x0000f8) << 13);
     
    }
}
    
inline void compose_555(unsigned int *ob, unsigned int *ub, Framebuffer *fb, int x0, int y0, int x1, int y1)
{

    

    int line      = x0+y0*fb->var.xres;
    int last_line = y1*fb->var.xres;
    unsigned char *line_rb = ((unsigned char *)fb->fb)+ (x0+y0*fb->var.xres)*2;
    
    while (line < last_line) {
      unsigned int *rb = (unsigned int *)line_rb;
      int i = line;
      int pixels = i+(x1-x0);

      while (i < pixels) {
         
	int p1 = compose_pixel(ob[i],ub[i]); i++;
	int p2 = compose_pixel(ob[i],ub[i]); i++;
	*(rb++) =  
	    ((p1 & 0xf80000) >> 9) | 
	    ((p1 & 0x00f800) >> 5) | 
	    ((p1 & 0x0000f8) >> 3) |
	    ((p2 & 0xf80000) << 7) | 
	    ((p2 & 0x00f800) << 11)| 
	    ((p2 & 0x0000f8) << 13);
     
      }

      line    += fb->var.xres;
      line_rb += fb->var.xres*2;
    }
}
    
inline void compose_BGR_24(unsigned int *ob, unsigned int *ub, Framebuffer *fb)
{
    int pixels = fb->var.xres*fb->var.yres;
    unsigned int *rb = (unsigned int *)fb->fb;
    int i = 0; 
    while (i < pixels) {
	
	int p1 = compose_pixel(ob[i],ub[i]); i++;
	int p2 = compose_pixel(ob[i],ub[i]); i++;
	int p3 = compose_pixel(ob[i],ub[i]); i++;
	int p4 = compose_pixel(ob[i],ub[i]); i++;

	*(rb++) =  
	    (p1  & 0x0000ff) |          // B  0 
	    (p1  & 0x00ff00) |          // G  1
	    (p1  & 0xff0000) |          // R  2
	    ((p2 & 0x0000ff) << 24);    // B  3

	*(rb++) =  
	    ((p2 & 0x00ff00) >> 8)|     // G  0
	    ((p2 & 0xff0000) >> 8)|     // R  1
	    ((p3 & 0x0000ff) << 16) |   // B  2
	    ((p3 & 0x00ff00) << 16);    // G  3

	*(rb++) =  
	    ((p3 & 0xff0000) >> 16)|    // R  0
	    ((p4 & 0x0000ff) << 8)|     // B  1
	    ((p4 & 0x00ff00) << 8)|     // G  2
	    ((p4 & 0xff0000) << 8);     // R  3
     
    }
}
    
inline void compose_BGR_24(unsigned int *ob, unsigned int *ub, Framebuffer *fb, int x0, int y0, int x1, int y1)
{

    

    int line      = x0+y0*fb->var.xres;
    int last_line = y1*fb->var.xres;
    unsigned char *line_rb = ((unsigned char *)fb->fb)+ (x0+y0*fb->var.xres)*3;
    
    while (line < last_line) {
      unsigned int *rb = (unsigned int *)line_rb;
      int i = line;
      int pixels = i+(x1-x0);

      while (i < pixels) {
         
	int p1 = compose_pixel(ob[i],ub[i]); i++;
	int p2 = compose_pixel(ob[i],ub[i]); i++;
	int p3 = compose_pixel(ob[i],ub[i]); i++;
	int p4 = compose_pixel(ob[i],ub[i]); i++;

	*(rb++) =  
	    (p1  & 0x0000ff) |          // B  0 
	    (p1  & 0x00ff00) |          // G  1
	    (p1  & 0xff0000) |          // R  2
	    ((p2 & 0x0000ff) << 24);    // B  3

	*(rb++) =  
	    ((p2 & 0x00ff00) >> 8)|     // G  0
	    ((p2 & 0xff0000) >> 8)|     // R  1
	    ((p3 & 0x0000ff) << 16) |   // B  2
	    ((p3 & 0x00ff00) << 16);    // G  3

	*(rb++) =  
	    ((p3 & 0xff0000) >> 16)|    // R  0
	    ((p4 & 0x0000ff) << 8)|     // B  1
	    ((p4 & 0x00ff00) << 8)|     // G  2
	    ((p4 & 0xff0000) << 8);     // R  3
     
      }

      line    += fb->var.xres;
      line_rb += fb->var.xres*3;
    }
}
    
inline void compose_BGR_32(unsigned int *ob, unsigned int *ub, Framebuffer *fb)
{
    int pixels = fb->var.xres*fb->var.yres;
    unsigned int *rb = (unsigned int *)fb->fb;
    int i = 0; 
    while (i < pixels) {
	
	*(rb++) = compose_pixel(ob[i],ub[i]); i++; 
     
    }
}
    
inline void compose_BGR_32(unsigned int *ob, unsigned int *ub, Framebuffer *fb, int x0, int y0, int x1, int y1)
{

    

    int line      = x0+y0*fb->var.xres;
    int last_line = y1*fb->var.xres;
    unsigned char *line_rb = ((unsigned char *)fb->fb)+ (x0+y0*fb->var.xres)*4;
    
    while (line < last_line) {
      unsigned int *rb = (unsigned int *)line_rb;
      int i = line;
      int pixels = i+(x1-x0);

      while (i < pixels) {
         
	*(rb++) = compose_pixel(ob[i],ub[i]); i++; 
     
      }

      line    += fb->var.xres;
      line_rb += fb->var.xres*4;
    }
}
    

void detectMode(Framebuffer *fb)
{
    fb->known_mode = FB_MODE_UNKNOWN;
     if (fb->var.bits_per_pixel == 16 &&
	    fb->var.red.length   == 5 && fb->var.red.offset   == 11 &&
	    fb->var.green.length == 6 && fb->var.green.offset == 5 &&
	    fb->var.blue.length  == 5 && fb->var.blue.offset  == 0) {
	fb->known_mode = FB_MODE_565;

    } else if (fb->var.bits_per_pixel == 16 &&
	    fb->var.red.length   == 5 && fb->var.red.offset   == 10 &&
	    fb->var.green.length == 5 && fb->var.green.offset == 5 &&
	    fb->var.blue.length  == 5 && fb->var.blue.offset  == 0) {
	fb->known_mode = FB_MODE_555;

    } else if (fb->var.bits_per_pixel == 24 &&
	    fb->var.red.length   == 8 && fb->var.red.offset   == 16 &&
	    fb->var.green.length == 8 && fb->var.green.offset == 8 &&
	    fb->var.blue.length  == 8 && fb->var.blue.offset  == 0) {
	fb->known_mode = FB_MODE_BGR_24;

    } else if (fb->var.bits_per_pixel == 32 &&
	    fb->var.red.length   == 8 && fb->var.red.offset   == 16 &&
	    fb->var.green.length == 8 && fb->var.green.offset == 8 &&
	    fb->var.blue.length  == 8 && fb->var.blue.offset  == 0) {
	fb->known_mode = FB_MODE_BGR_32;

    } else {
	fprintf(stderr, "Warning: Unknown %i bpp mode: r:%i@%i, g:%i@%i b:%i@%i (performance will be bad!)\n\n",
		fb->var.bits_per_pixel,
		fb->var.red.length, fb->var.red.offset,
		fb->var.green.length, fb->var.green.offset,
		fb->var.blue.length, fb->var.blue.offset
	    );
    }
}

void compose_FB(unsigned int *ob, unsigned int *ub, Framebuffer *fb) {
     if (fb->known_mode == FB_MODE_565) {
	compose_565(ob, ub, fb);
    } else if (fb->known_mode == FB_MODE_555) {
	compose_555(ob, ub, fb);
    } else if (fb->known_mode == FB_MODE_BGR_24) {
	compose_BGR_24(ob, ub, fb);
    } else if (fb->known_mode == FB_MODE_BGR_32) {
	compose_BGR_32(ob, ub, fb);
    } else {
	compose_UNKNOWN(ob, ub, fb);
    }
}
void compose_FB(unsigned int *ob, unsigned int *ub, Framebuffer *fb, int x0, int y0, int x1, int y1) {
     if (fb->known_mode == FB_MODE_565) {
	compose_565(ob, ub, fb, x0, y0, x1, y1);
    } else if (fb->known_mode == FB_MODE_555) {
	compose_555(ob, ub, fb, x0, y0, x1, y1);
    } else if (fb->known_mode == FB_MODE_BGR_24) {
	compose_BGR_24(ob, ub, fb, x0, y0, x1, y1);
    } else if (fb->known_mode == FB_MODE_BGR_32) {
	compose_BGR_32(ob, ub, fb, x0, y0, x1, y1);
    } else {
	compose_UNKNOWN(ob, ub, fb, x0, y0, x1, y1);
    }
}
