
#ifndef COMPOSERS_H
#define COMPOSERS_H

#include "framebuffer.h"

/*
 The FB_MODE_ constants are used to identify the known modes of the
 frame buffer and select a suitable compositor later, if the mode is
 not one of the known types then a generic and very slow compositor
 will be used, so make every effort to find a supported mode.

 DONT EDIT THIS FILE, IT IS GENERATED BY generate_composers
*/
void detectMode(Framebuffer *fb);
void compose_FB(unsigned int *ob, unsigned int *ub, Framebuffer *fb);
void compose_FB(unsigned int *ob, unsigned int *ub, Framebuffer *fb, int x0, int y0, int x1, int y1);

#define FB_MODE_UNKNOWN 0
inline void compose_UNKNOWN(unsigned int *ob, unsigned int *ub, Framebuffer *fb);
inline void compose_UNKNOWN(unsigned int *ob, unsigned int *ub, Framebuffer *fb, int x0, int y0, int x1, int y1);
#define FB_MODE_565 1
inline void compose_565(unsigned int *ob, unsigned int *ub, Framebuffer *fb);
inline void compose_565(unsigned int *ob, unsigned int *ub, Framebuffer *fb, int x0, int y0, int x1, int y1);
#define FB_MODE_555 2
inline void compose_555(unsigned int *ob, unsigned int *ub, Framebuffer *fb);
inline void compose_555(unsigned int *ob, unsigned int *ub, Framebuffer *fb, int x0, int y0, int x1, int y1);
#define FB_MODE_BGR_24 3
inline void compose_BGR_24(unsigned int *ob, unsigned int *ub, Framebuffer *fb);
inline void compose_BGR_24(unsigned int *ob, unsigned int *ub, Framebuffer *fb, int x0, int y0, int x1, int y1);
#define FB_MODE_BGR_32 4
inline void compose_BGR_32(unsigned int *ob, unsigned int *ub, Framebuffer *fb);
inline void compose_BGR_32(unsigned int *ob, unsigned int *ub, Framebuffer *fb, int x0, int y0, int x1, int y1);
#endif
